
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>页面跳转？sendRedirect()与forward()辨析 / 憋错料</title>

    <meta name="description" content="页面跳转？sendRedirect()与forward()辨析 在JSP中,要实现页面的跳转,主要有两种方式实现:forward和sendRedirect. 一.forward forward实现页面跳转是通过转移请求实现的.客户端向服务器的页面1发出一个请求,页面1编译运行过程中发现处理不了,把这个请求转移(forward)给页面2来处理,这个请求对象封装了一开始客户端发送请求时封装的信息.参数等.页面2对通过这个请求对象提取数据并进行一系列的操作处理后,把结果通过response发回原客户端浏览器显示.整个过程中只发生了一次请求.一次响应.由于宏观上是客">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">页面跳转？sendRedirect()与forward()辨析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>　</p>
<p>　在JSP中，要实现页面的跳转，主要有两种方式实现：forward和sendRedirect。</p>
<p>　　一、forward</p>
<p>　　forward实现页面跳转是通过转移请求实现的。客户端向服务器的页面1发出一个请求，页面1编译运行过程中发现处理不了，把这个请求转移（forward）给页面2来处理，这个请求对象封装了一开始客户端发送请求时封装的信息、参数等。页面2对通过这个请求对象提取数据并进行一系列的操作处理后，把结果通过response发回原客户端浏览器显示。整个过程中只发生了一次请求、一次响应。由于宏观上是客户端向页面1发出的请求并通过response收到了响应，所以地址栏上显示的是页面1的地址。而在微观上，即服务器内部页面1调用了多少页面，客户端是不知的。如下图：</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwMTg1NDEvMjAxNjExLzEwMTg1NDEtMjAxNjExMDgyMTU3MjMzNDItMzY0ODk0MTI3LnBuZw==.jpg"></p>
<p>　　二、sendRedirect()</p>
<p>　　response.sendRedirect("跳转页面?参数&amp;参数...");</p>
<p>　　重定向实际上相当于指引浏览器向另一个页面进行请求。客户端向页面1发出请求，页面1回应客户端说：“你去找页面2吧！”，通过response对象把页面2的地址以及参数发回给客户端。然后客户端又通过1发来的地址向页面2发出请求并把参数传过去，页面2接收请求并处理后再通过response把结果返回客户端显示。整个过程实际上发生了两次请求、两次响应。两次的请求响应分别独立，互不相同的。由于客户端是进行了两次请求的，所以地址栏上先是页面1的地址然后重定向后显示的是页面2的地址。</p>
<p>　　如下图：</p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwMTg1NDEvMjAxNjExLzEwMTg1NDEtMjAxNjExMDgyMjA4MjAyMDItMTg3ODQ5OTEyMS5wbmc=.jpg"></p>
<p>　　</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 23:54:37 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ons/" title="ons">ons</a>, <a href="https://www.biecuoliao.com/tag/%e5%9c%b0%e5%9d%80/" title="地址">地址</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e7%8e%b0/" title="实现">实现</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%87%e7%a8%8b/" title="过程">过程</a>, <a href="https://www.biecuoliao.com/tag/rect/" title="rect">rect</a>, <a href="https://www.biecuoliao.com/tag/%e8%b0%83%e7%94%a8/" title="调用">调用</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%8d%e5%8a%a1/" title="服务">服务</a>, <a href="https://www.biecuoliao.com/tag/%e5%93%8d%e5%ba%94/" title="响应">响应</a>, <a href="https://www.biecuoliao.com/tag/%e9%a1%b5%e9%9d%a2%e8%b7%b3%e8%bd%ac/" title="页面跳转">页面跳转</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>页面跳转？sendRedirect()与forward()辨析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k17DP4.html" rel="bookmark">JS弹出框、对话框、提示框，JS关闭窗口、关闭页面和JS控制页面跳转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.JS弹出框.对话框.提示框 //====================== JS最常用三种弹出对话框 ======================== //1弹出对话框并输出一段提示信息 function ale() { //弹出一个对话框 alert(&quot;提示信息!&quot;); } //2弹出一个询问框,有确定和取消按钮 function firm() { //利用对话框返回的值 (true 或者 false) if (confirm(&quot;你确定提交吗?&quot;)) { a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGRXEb4.html" rel="bookmark">jsp页面跳转和请求的各种方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;%@ page language=&quot;java&quot; contentType=&quot;text/html; charset=utf-8&quot; pageEncoding=&quot;utf-8&quot;%&gt; &lt;!DOCTYPE html &gt; &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=utf-8			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35Nbao4.html" rel="bookmark">JSP与Servlet几种页面跳转的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Servlet: 当然,在servlet中,一般跳转都发生在doGet, doPost等方法里面. 1) redirect 方式 response.sendRedirect(&quot;/a.jsp&quot;); 页面的路径是相对路径.sendRedirect可以将页面跳转到任何页面,不一定局限于本web应用中,如: response.sendRedirect(&quot;http://www.ycul.com&quot;); 跳转后浏览器地址栏变化. 这种方式要传值出去的话,只能在url中带param			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDjyA93.html" rel="bookmark">页面跳转与重定向&lpar;之二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 这一篇是接着上一篇的继续 页面跳转与重定向(之一) 在上一篇中, 介绍了在html,js 和JSP中如何跳转和重定向. 基本是在页面层级进行页面的跳转, 进入一个页面后跳入另一个页面. 这一篇将从项目和服务端来看看有可能在实际的项目中使用到的状况. 旧的地址跳转到新的地址 在系统开发过程中, 新旧系统并存是一种常见的处理方法,新旧系统有着各自独立的域名地址. . 当新系统开发完成的时候,就需要把旧地址的域名导到新地址中了. 方法之一 就是进行DNS 修改映射了. 如果系统没有域名, 只有I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k6D7PM.html" rel="bookmark">java servlet 几种页面跳转的方法及传值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java web 页面之间传值有一下这几种方式1.form 表单传递参数2.url地址栏传递参数3.session4.cookie5.application 6.通过隐藏域传值 7.通过JavaBean进行传值 8. request.setAttribute(&quot;strRequest&quot;, strRequest); 9.response.setAttribute(&quot;name&quot;,name)来传至下一个页面 10.response.sendRedirect():在用户的浏览			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49lwKJ3.html" rel="bookmark">web项目中实现页面跳转的两种方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;a href=&quot;javascript:&quot;&gt;&lt;/a&gt;跳转在网页本身,URL不改变 &lt;a href=&quot;#&quot;&gt;&lt;/a&gt; 跳转在网页本身,URL 改变 java web项目中实现页面跳转的主要方式有两种:第一种,&lt;% response.sendRedirect(&quot;index.jsp&quot;);%&gt;第二种&lt;jsp:forward page=&quot;index.jsp&quot;/&gt;我做			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVRE9zM.html" rel="bookmark">Servlet、JSP中页面跳转的方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Servlet:当然,在servlet中,一般跳转都发生在doGet, doPost等方法里面.1)  redirect 方式response.sendRedirect(&quot;success.jsp&quot;);页面的路径是相对路径.sendRedirect可以将页面跳转到任何页面,不一定局限于本web应用中,如:response.sendRedirect(&quot;http://www.ycul.com&quot;);跳转后浏览器地址栏变化.这种方式要传值出去的话,只能在url中带para			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ba1EkM.html" rel="bookmark">关于jsp页面跳转及参数传递的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在做网站的登录功能,目前有这几个文件:index.jsp(登录页面),userLogin.jsp(登录验证页面,登录成功跳到user.jsp,登录失败跳回index.jsp)与数据库相连,user.jsp(用户个人主页).想要达到以下目的: 1.输入正确的用户名和密码,成功登录. 2.输入错误的用户名或密码,登录失败,跳回index.jsp提示登录失败,请重新登录. 关于页面的跳转问题,在登录成功时,要向user.jsp传递用户名,登录失败时,要跳回原来的index.jsp页面,并要告知in			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MowWJyM.html" rel="bookmark">Java Web页面跳转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java Web的页面跳转分服务器跳转和客户端跳转: 服务器端跳转  的特点是:跳转之后浏览器的地址栏不会发生任何变化,在使用rquest属性范围时,能将request属性保存到跳转页.执行到跳转语句则会立即跳转. 例如:&lt;jsp:forward page=&quot;login.htm&quot;&gt;&lt;/jsp&gt; 或者:&lt;jsp:forward page=&quot;login.htm&quot;&gt; &lt;jsp:param name=&quot;id&quot; v			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzQJW4.html" rel="bookmark" class="title">Android 最火开发框架 xUtils</a>
					<div>
						xUtils简介 xUtils3 api变化较多, 已转至 https://github.com/wyouflf/xUtils3 xUtils 2.x对Android 6.0兼容不是很好, 请尽快升级 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyD1V4.html" rel="bookmark" class="title">MySQL的外键约束：Cascade&sol;Restrict&sol;No action&sol;SET NULL</a>
					<div>
						转自:http://blog.csdn.net/cnjsnt_s/article/details/5548280 具体使用时需要参考:http://blog.csdn.net/codeforme/ar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgq9O3.html" rel="bookmark" class="title">nginx的安装</a>
					<div>
						nginx安装环境 nginx是C语言开发,建议在linux上运行,本教程使用Centos6.5作为安装环境. n  gcc 安装nginx需要先将官网下载的源码进行编译,编译依赖gcc环境,如果没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0YKwq4.html" rel="bookmark" class="title">371&period; Sum of Two Integers</a>
					<div>
						Calculate the sum of two integers a and b, but you are not allowed to use the operator + and -. Exam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0drr94.html" rel="bookmark" class="title">通知中心 － NSNotificationCenter</a>
					<div>
						---恢复内容开始--- NS_ASSUME_NONNULL_BEGIN /**************** Notifications ****************/ // 通知,被发送,被接受 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d57kz3.html" rel="bookmark" class="title">实例1 -- 判断输入年份是否为闰年</a>
					<div>
						闰年的条件: 能被4整除且不能被100整除的为闰年或能被400整除 则为闰年 java写法: --------------------------------------------------- i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4186Ev3.html" rel="bookmark" class="title">java&period;io&period;BufferedOutputStream 源码分析</a>
					<div>
						BufferedOutputStream  是一个带缓冲区到输出流,通过设置这种输出流,应用程序就可以将各个字节写入底层输出流中,而不必针对每次字节写入调用底层系统. 俩个成员变量,一个是存储数据的内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5OkoM.html" rel="bookmark" class="title">第五课作业</a>
					<div>
						一.项目进度管理1.进度管理包括哪六个过程?P247 答:活动定义.活动排序.活动资源估算.活动历时估算.制定进度表与进度控制. 2.什么是滚动式规划?P252 答:也是滚动波浪计划,是规划不断完善的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDro8Y3.html" rel="bookmark" class="title">R语言中的 Vector&comma; Array&comma; List 和 Data Frame</a>
					<div>
						1.Vector 所有的元素必须是同一类型. 例如下面的代码创建了2个vectors. name &lt;- c(&quot;Mike&quot;, &quot;Lucy&quot;, &quot;J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDG8qM.html" rel="bookmark" class="title">Linux学习笔记之命令技巧、bash支持的引号作用及文件通配符</a>
					<div>
						命令技巧: 命令行使用技巧: Ctrl + a  光标跳转行首 Ctrl + e  光标跳转行尾 Ctrl + u  删除光标至行首的内容 Ctrl  + k  删除光标至行尾内容 Ctrl  + l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPJwo4.html" rel="bookmark" class="title">OS应用架构谈（二）：View层的组织和调用方案（中）</a>
					<div>
						OS应用架构谈(二):View层的组织和调用方案(中) 作者 田伟宇 发布于 2015年5月28日 | 注意: ArchSummit全球架构师峰会(北京)2015年12月18-19日,了解更多详情!讨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471A9D0.html" rel="bookmark" class="title">集群与分布式 如何理解（自己的理解）</a>
					<div>
						集群 与 分布式 如何理解 一. 概念理解 集群的理解:就是一台计算机处理不了太多的事情 ,需要大家组合在一起来完成一件事情. 分布式的理解:就是把一件事情分成好几个部分 ,每个人做其中的一部分. 二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrWvm4.html" rel="bookmark" class="title">javaScript for循环</a>
					<div>
						for(语句1;语句2;语句3){ //被执行的代码块; } 语句1: 在循环开始前执行; 语句2: 定义运行循环的条件; 语句3: 在循环已被执行之后执行; 通常说,语句1.2.3都是可选的 语句2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzko980.html" rel="bookmark" class="title">关于正则表达式的一个小总结</a>
					<div>
						1.正则表达式基本语法 两个特殊的符号'^'和'$'.他们的作用是分别指出一个字符串的开始和结束.例子如下: &quot;^The&quot;:表示所有以&quot;The&quot;开始的字符串(& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0negEoM.html" rel="bookmark" class="title">CCASS四种交收指令</a>
					<div>
						CCASS 提供了4种类型的指令:ATI: Account Transfer Instruction 账户转移指令,用于本券商各个仓位上的转移STI: Stock Segregate Account  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoRR7w4.html" rel="bookmark" class="title">Redhat7&period;0安装</a>
					<div>
						Redhat7.0发布之后,一直没时间去看,最近打算安装一个试试手感. Redhat7.0版本还在测试阶段,而相对以前的版本来说,变化是非常大的,首先是界面有点fedora的味道,其次redhat7. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDn5Op3.html" rel="bookmark" class="title">学习App&colon;2015年三款人气学习类手机应用推荐</a>
					<div>
						时下流行起来零碎时间学习,各位低头族不要在无聊的滑动已经更新过几次的状态啦,下点学习App吧,不知不觉你就把别人摔在后头啦,嘘,别声张! 下面推荐的几款各有千秋,主题功能都有练习冲刺,错题本,成绩反馈 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWb5J4.html" rel="bookmark" class="title">phone Extension 用法基础详解</a>
					<div>
						1 首先我们需要创建一个phone Extension target当然我们也必须知道Extension app必须在一个containg app内 我们从建立一个target开始 选择菜单 file ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQOmKM.html" rel="bookmark" class="title">Java代码实现向Oracle数据库中导入已备份的数据库文件</a>
					<div>
						今天将很早就实现的一个Oracle数据库备份功能粘贴出来,这个功能是在大学做阶段设计时写的: import java.io.IOException; /** * Java代码实现向Oracle数据库中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41yNyJ4.html" rel="bookmark" class="title">poj 1860 Currency Exchange（SPFA）</a>
					<div>
						题目链接:http://poj.org/problem?id=1860 Description Several currency exchange points are working in our  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
